#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_color3  White
//---- input parameters
extern bool   T3Original =false;
extern int    T3_PeriodFast=13;// 5    
extern int    T3_PeriodSlow=21;//13
extern int    T3_PeriodSignal=8;
extern bool ShowLevels=false;
extern double LevelFilter=0.0004;

//---- buffers
double MacdBuffer[];
double SignalBuffer[];
double FastEMABuffer[];
double SlowEMABuffer[];
double SignalEMABuffer[];
double T3_Factor=0.618;
double     Up[],Down[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
      SetIndexBuffer(0, Up);
   SetIndexBuffer(1, Down);
   SetIndexBuffer(2, SignalBuffer);
   SetIndexBuffer(3, FastEMABuffer);
   SetIndexBuffer(4, SlowEMABuffer);
   SetIndexBuffer(4, SignalEMABuffer);
      SetIndexBuffer(5, MacdBuffer);

   SetIndexStyle(0, DRAW_HISTOGRAM,0,4);
      SetIndexStyle(1, DRAW_HISTOGRAM,0,4);

   SetIndexStyle(2, DRAW_LINE,0,2);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
ArraySetAsSeries(SignalBuffer, TRUE);
   ArraySetAsSeries(MacdBuffer, TRUE);
if (ShowLevels){
SetLevelValue(0,LevelFilter);
SetLevelValue(1,-LevelFilter);
SetLevelStyle(STYLE_DOT,0,Magenta);
}
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
   double EMA, ZeroLagEMAp, ZeroLagEMAq;
   for(int i = 0; i < limit; i++)
     {
       FastEMABuffer[i] = iCustom(Symbol(), 0,"T3",T3Original,T3_PeriodFast,T3_Factor,0, i);
       SlowEMABuffer[i] = iCustom(Symbol(), 0,"T3",T3Original,T3_PeriodSlow,T3_Factor,0, i);
     }
   for(i = 0; i < limit; i++)
     {
        EMA = iMAOnArray(FastEMABuffer, 0, T3_PeriodFast, 0, MODE_EMA, i);
        ZeroLagEMAp = FastEMABuffer[i] + FastEMABuffer[i] - EMA;
        EMA = iMAOnArray(SlowEMABuffer, 0, T3_PeriodSlow, 0, MODE_EMA, i);
        ZeroLagEMAq = SlowEMABuffer[i] + SlowEMABuffer[i] - EMA;
        MacdBuffer[i] = ZeroLagEMAp - ZeroLagEMAq;
     }
   for(i = 0; i < limit; i++)
       SignalEMABuffer[i] = iMAOnArray(MacdBuffer,0, T3_PeriodSignal, 0, MODE_EMA, i);
   for(i = 0; i < limit; i++)
     {
       EMA = iMAOnArray(SignalEMABuffer,0, T3_PeriodSignal, 0, MODE_EMA, i);
       SignalBuffer[i] = SignalEMABuffer[i] + SignalEMABuffer[i] - EMA;
     }
     
     for (i=limit; i>=0; i--)
{
 
  Up[i]=EMPTY_VALUE;
  Down[i]=EMPTY_VALUE;
 
 if(MacdBuffer[i]>MacdBuffer[i+1]){
 Up[i]=MacdBuffer[i];

 }
  if(MacdBuffer[i]<MacdBuffer[i+1]){
Down[i]=MacdBuffer[i];

}
}
   return(0);
  }
//+------------------------------------------------------------------+